#!/usr/bin/perl
################################################################################
# NDump v0.1 by h1kari, for Perl with Net::RawIP mods.                         #
# [http://www.nfsg.org] (Nightfall Security Group)                             #
# Usage: ndump.pl [-o<outfile>][-d<device>]                                    #
# Net::RawIP libpcap based network dump program for Linux/*BSD systems.        #
# This program basically dumps all packets on the network to a file in a raw   #
# data format. Then you can use the parser to filter through the dump file and #
# get the info you need.                                                       #
#                                                                              #
################################################################################
# Optional Configuration Settings                               # Descriptions #
################################################################################
my($psize)=1024;                                                # Buffer Size  #
my($ptout)=64;                                                  # Timeout      #
my($ver)='0.1';                                                 # ver control  #
################################################################################

my($p,@p,$pdev,%opt); $|=1;

use Net::RawIP;
use sigtrap 'handler',\&close_pcap,'normal-signals';
use FileHandle;
use Getopt::Std;

getopts('o:d:',\%opt);

if(!defined($opt{'o'})) {
 print "-"x78 .
       "\nNDump v$ver by h1kari, for Perl with Net::RawIP mods.\n".
       "[http://www.nfsg.org] (Nightfall Security Group)\n".
       "-"x78 ."\n".
       "Usage: ndump.pl <-o<outfile>>[-d<device>]\n".
       "                 -o: specifies an output file\n".
       "                 -d: specifies the device to use\n\n"; exit }

open(OUT,">$opt{'o'}") || die "Outfile: Unable to open '$opt{'o'}'..\n";
autoflush OUT;
print "Outfile: Found, Using '$opt{'o'}'..\n";
(defined($opt{'d'})) && ($pdev=$opt{'d'}) ||
 ($pdev=Net::RawIP::lookupdev($ptout));
$p=new Net::RawIP({ip=>{}});
$psck=$p->pcapinit($pdev," ",$psize,$ptout) || die "Cannot Initialize Pcap..\n";
print "Device: $pdev..\n";
$offset=Net::RawIP::linkoffset($psck) || die "Link Offset Not Supported..\n";
print "Link Offset: $offset..\n";
print OUT pack("a4L",$pdev,$offset);
loop $psck,-1,\&parse,@p;

sub parse { print OUT pack('LLa*',time,length($_[2]),$_[2]); print '.' }

sub close_pcap { close(OUT); print "\n"; exit }
